<template>
  <v-container>
    <v-row class="text-center">
      <v-col class="mb-4 offset-mb-4">
        <h2 class="font-weight-bold mb-3">Term search</h2>
        <p class="subheading font-weight-regular">
          Search ontology entities for an exact term (deterministic search), or
          terms similar to the provided one (probabilistic search).
        </p>
      </v-col>
    </v-row>
    <div v-if="fetching">
      <v-row align="center">
        <v-col class="mb-4 offset-mb-4">
          <v-img
            :src="
              $vuetify.theme.dark
                ? require('../assets/loading_dark.gif')
                : require('../assets/loading_light.gif')
            "
            class="my-3"
            contain
            height="60"
          />
        </v-col>
      </v-row>
      <v-row align="center" v-if="withSimilar">
        <v-col class="mb-4 offset-mb-4">
          <div style="text-align: center">
            This will take a couple of minutes...
          </div>
        </v-col>
      </v-row>
    </div>
    <v-row align="center" v-else>
      <v-col class="d-flex" md="4">
        <v-text-field :disabled="fetched" v-model="term" label="Term" solo />
      </v-col>
      <v-col class="d-flex" md="4">
        <v-select
          v-model="selectedDomain"
          :disabled="fetched"
          :items="domains"
          label="Select domain"
          solo
        ></v-select>
      </v-col>
      <v-col class="d-flex mt-n4" md="2">
        <v-switch
          :disabled="fetched"
          v-model="withSimilar"
          label="probabilistic search"
        ></v-switch>
      </v-col>
      <v-col class="d-flex mt-n4" md="2">
        <v-btn
          @click="submit"
          color="primary"
          :disabled="fetching || term === '' || selectedDomain === ''"
          style="padding: 0 10px"
        >
          {{ goBtn }}
        </v-btn>
      </v-col>
    </v-row>
    <v-card :v-sohw="results !== null">
      <v-data-table
        v-if="results !== null"
        :headers="headers"
        :items="results"
        :items-per-page="20"
        :footer-props="{
          showFirstLastPage: true,
          itemsPerPageOptions: [10, 20, 40, 80, -1],
        }"
      >
      </v-data-table>
    </v-card>
  </v-container>
</template>

<script lang="ts">
import Vue from "vue";
import { readDomains } from "@/store/main/getters";
import { api } from "@/api";
import { AppNotification } from "@/interfaces";
import { commitAddNotification } from "@/store/main/mutations";
import {
  dispatchGetDomains,
  dispatchRemoveNotification,
} from "@/store/main/actions";
import {
  SimpleSearchResponse,
  ExtendedSearchResponse,
  SimpleSearchResult,
  ExtendedSearchResult,
} from "@/interfaces/SearchResults";

export default Vue.extend({
  name: "Search",
  data: () => ({
    fetching: false,
    fetched: false,
    withSimilar: false,
    selectedDomain: "",
    term: "",
    results: null as SimpleSearchResult[] | ExtendedSearchResult[] | null,
  }),
  mounted() {
    if (readDomains(this.$store) == null) {
      dispatchGetDomains(this.$store);
    }
  },

  computed: {
    goBtn: function (): string {
      return this.fetched ? "Clear" : "Go!";
    },
    domains: function (): string[] {
      return readDomains(this.$store) ?? [];
    },
    headers: function (): Array<{ [key: string]: unknown }> {
      if (this.withSimilar) {
        return [
          { text: "Ontology", value: "ontology" },
          { text: "Term", value: "term" },
          { text: "Cosine Similarity", value: "cosineSimilarity" },
          { text: "Transformer Similarity", value: "transformerSimilarity" },
        ];
      }
      return [
        { text: "Entity", value: "entity" },
        { text: "Ontology", value: "ontology" },
      ];
    },
  },
  methods: {
    submit: async function (): Promise<void> {
      if (this.fetched) {
        this._clear();
      } else {
        await this._doSearch();
      }
    },
    _clear: function (): void {
      this.fetching = false;
      this.fetched = false;
      this.term = "";
      this.results = null;
      this.selectedDomain = "";
    },
    _doSearch: async function (): Promise<void> {
      this.fetching = true;
      this.fetched = false;
      this.results = null;
      const loadingNotification: AppNotification = {
        content: "Searching...",
        color: "info",
      };
      commitAddNotification(this.$store, loadingNotification);
      try {
        const response = await api.search(
          this.selectedDomain,
          this.term,
          !this.withSimilar
        );
        await dispatchRemoveNotification(this.$store, {
          notification: loadingNotification,
          timeout: 200,
        });
        if (response.status === 200) {
          this.fetched = true;
          commitAddNotification(this.$store, {
            content: "Fetched results",
            color: "success",
          });
          if (this.withSimilar) {
            const _results = response.data as ExtendedSearchResponse;
            this.results = Object.keys(_results.ontologies).map(
              (key, index) => {
                return {
                  ontology: _results.ontologies[index],
                  term: _results.terms[index],
                  cosineSimilarity: _results.cosine_similarity[index],
                  transformerSimilarity: _results.transformer_similarity[index],
                };
              }
            ) as ExtendedSearchResult[];
          } else {
            const _results = response.data as SimpleSearchResponse;
            this.results = Object.keys(_results.ontologies).map(
              (key, index) => {
                return {
                  ontology: _results.ontologies[index],
                  entity: _results.entities[index],
                };
              }
            );
          }
        } else {
          commitAddNotification(this.$store, {
            content: "Could not get results :(",
            color: "error",
          });
        }
        this.fetching = false;
      } catch (error) {
        console.warn(error);
        await dispatchRemoveNotification(this.$store, {
          notification: loadingNotification,
          timeout: 200,
        });
        commitAddNotification(this.$store, {
          content: "Something went wrong :(",
          color: "error",
        });
        this.fetching = false;
        this.fetched = false;
      }
    },
  },
});
</script>
